with AVR.Wait;	

package body i_wire is

	procedure tau_time is new AVR.Wait.Generic_Wait_Usecs(Crystal_Hertz => Crystal_Hertz, Micro_Seconds => tau);
	procedure one_time is new AVR.Wait.Generic_Wait_Usecs(Crystal_Hertz => Crystal_Hertz, Micro_Seconds => tau*3/2);
	procedure zero_time is new AVR.Wait.Generic_Wait_Usecs(Crystal_Hertz => Crystal_Hertz, Micro_Seconds => tau/2);

	procedure Put(value: Unsigned_8) is		
		value_bits: bits_in_byte;		
		for value_bits'address use value'address;		
	begin
		for i in bit_number'Range loop
			Tx := high;
			tau_time;
			Tx := low;
			if value_bits(i) then one_time; else zero_time; end if;
		end loop;
		Tx:=high; 
		tau_time; 
		Tx:=low;
		tau_time;
		tau_time;
		tau_time;
	end Put;


begin

	null;

end i_wire;