
package body interrupt_handler is
	
	procedure WDT_int;
	pragma Machine_Attribute(Entity	=> WDT_int, Attribute_Name	=> "signal");
	pragma Export(C, WDT_int, AVR.MCU.Sig_WDT_String);

	procedure WDT_int is		
	begin
		null;
	end WDT_int;
	
	
	procedure ADC_Complit;
	pragma Machine_Attribute (Entity => ADC_Complit, Attribute_Name => "signal");
	pragma Export (C, ADC_Complit, AVR.MCU.Sig_ADC_String);

	procedure ADC_Complit is
		l: Unsigned_8;
	begin				
		
		l := ADCL;
		
		case ADCH is
			when 2#00# => current_filter(filter_pointer) := 255;
			when 2#01# => current_filter(filter_pointer) := 255 - l;
			when others => current_filter(filter_pointer) := 0;
		end case;
		
		if current_filter(filter_pointer)>=overcurrent_treshold then
			OCR0A := 0;
			overcurrent_flag := true;
		end if;
		
		filter_pointer := filter_pointer + 1;
				
	end ADC_Complit;

begin
	null;
end interrupt_handler;